Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/DoubleVariable.cs	(revision 9194)
@@ -0,0 +1,162 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item(Name = "DoubleVariable", Description = "")]
+  public class DoubleVariable : Variable<double> {
+    public override int VirtualLength {
+      get { return 2; }
+    }
+
+    [Storable]
+    protected double min;
+    public double Min {
+      get { return min; }
+    }
+    [Storable]
+    protected double max;
+    public double Max {
+      get { return max; }
+    }
+
+    [Storable]
+    protected double currentCenter;
+    public double CurrentCenter {
+      get { return currentCenter; }
+      set { currentCenter = value; }
+    }
+
+    [Storable]
+    protected double currentSpread;
+    public double CurrentSpread {
+      get { return currentSpread; }
+      set { currentSpread = value; }
+    }
+
+    [StorableConstructor]
+    protected DoubleVariable(bool deserializing) : base(deserializing) { }
+    protected DoubleVariable(DoubleVariable original, Cloner cloner)
+      : base(original, cloner) {
+      min = original.min;
+      max = original.max;
+    }
+    public DoubleVariable() : base() { }
+    public DoubleVariable(string variableName, IEnumerable<double> variableValues)
+      : base(variableName) {
+      min = variableValues.Min();
+      max = variableValues.Max();
+    }
+    protected DoubleVariable(string variableName, double min, double max)
+      : base(variableName) {
+      this.min = min;
+      this.max = max;
+    }
+    public DoubleVariable(string variableName, IEnumerable<double> variableValues, double center, double spread)
+      : this(variableName, variableValues) {
+      CurrentCenter = center;
+      CurrentSpread = spread;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DoubleVariable(this, cloner);
+    }
+
+    public override string ToString() {
+      return (currentCenter - currentCenter) + " - " + (currentCenter + currentSpread);
+    }
+
+    public override bool MatchInput(string target) {
+      return Match(Double.Parse(target));
+    }
+
+    public override bool Match(double target) {
+      return currentCenter - currentSpread < target && target < currentCenter + currentSpread;
+    }
+
+    public new DoubleVariable GetEmptyCopy() {
+      return new DoubleVariable(variableName, min, max);
+    }
+    public new DoubleVariable GetSetCopy() {
+      DoubleVariable copy = GetEmptyCopy();
+      copy.CurrentCenter = this.CurrentCenter;
+      copy.CurrentSpread = this.CurrentSpread;
+      return copy;
+    }
+
+    // Important! If this mehtod is called instead of the more concrete "Randomize(IRandom random, double spreadPercentage)"
+    // spread percentage is 50%
+    public override void Randomize(IRandom random) {
+      Randomize(random, 50);
+    }
+
+    public void Randomize(IRandom random, double spreadPercentage) {
+      if (spreadPercentage < 0 || spreadPercentage > 100) {
+        throw new ArgumentException("Spread percentage has to be between 0 and 100.");
+      }
+      double delta = Max - Min;
+      CurrentCenter = random.NextDouble() * delta + Min;
+      CurrentSpread = random.NextDouble() * (delta * (spreadPercentage / 100));
+    }
+
+    public override bool Identical(IVariable target) {
+      var targetCast = target as DoubleVariable;
+      if (targetCast == null) { return false; }
+      if (variableName != targetCast.variableName || currentCenter != targetCast.currentCenter
+        || currentSpread != targetCast.currentSpread || max != targetCast.max
+        || min != targetCast.min) { return false; }
+
+      return true;
+    }
+
+    public override double GetGenerality() {
+      double delta = max - min;
+      double intervalWidth = 2 * currentSpread;
+      double generality = intervalWidth / delta;
+      return generality > 1 ? 1 : generality;
+    }
+
+    public override bool IsGreaterThanOrEquallyGeneral(IVariable target) {
+      var targetCast = target as DoubleVariable;
+      if (targetCast == null) { return false; }
+      return currentCenter - currentSpread < targetCast.currentCenter - targetCast.currentSpread
+        && currentCenter + currentSpread > targetCast.currentCenter + targetCast.currentSpread;
+    }
+
+    public new DoubleVariable CrossParentsAtPosition(IVariable parent2, int pos) {
+      var parent2Cast = parent2 as DoubleVariable;
+      if (parent2Cast == null) { throw new ArgumentException("Argument is not of the correct type."); }
+      if (pos > 1 || pos < 0) { throw new ArgumentOutOfRangeException(); }
+      DoubleVariable crossed = this.GetSetCopy();
+      if (pos == 0) {
+        crossed.CurrentSpread = parent2Cast.CurrentSpread;
+      }
+      return crossed;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IActionVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IActionVariable.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IActionVariable.cs	(revision 9194)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Encodings.VariableVector {
+  // variables which can be used in the action
+  public interface IActionVariable : IVariable {
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IVariable.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IVariable.cs	(revision 9194)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  public interface IVariable : IItem {
+    string VariableName { get; }
+    int VirtualLength { get; }
+    Type VariableType { get; }
+
+    IVariable GetEmptyCopy();
+    IVariable GetSetCopy();
+    void Randomize(IRandom random);
+    bool MatchInput(string target);
+    bool MatchVariable(IVariable target);
+
+    bool Identical(IVariable target);
+
+    double GetGenerality();
+    bool IsGreaterThanOrEquallyGeneral(IVariable target);
+
+    IVariable CrossParentsAtPosition(IVariable parent2, int pos);
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/IntVariable.cs	(revision 9194)
@@ -0,0 +1,148 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item(Name = "IntVariable", Description = "")]
+  public class IntVariable : Variable<int>, IActionVariable {
+
+    public override int VirtualLength {
+      get { return 1; }
+    }
+
+    [Storable]
+    public bool Wildcard { get; set; }
+
+    [Storable]
+    protected IEnumerable<int> possibleFeatures;
+    public IEnumerable<int> PossibleFeatures {
+      get { return possibleFeatures; }
+    }
+
+    [Storable]
+    protected int currentValue;
+    public int CurrentValue {
+      get { return currentValue; }
+      set {
+        if (!possibleFeatures.Contains(value)) {
+          throw new ArgumentException("Value is not a possible feature of this variable.");
+        }
+        currentValue = value;
+      }
+    }
+
+    [StorableConstructor]
+    protected IntVariable(bool deserializing) : base(deserializing) { }
+    protected IntVariable(IntVariable original, Cloner cloner)
+      : base(original, cloner) {
+      this.possibleFeatures = new List<int>(original.possibleFeatures);
+      this.Wildcard = original.Wildcard;
+    }
+    public IntVariable()
+      : base() {
+      Wildcard = false;
+    }
+    public IntVariable(string variableName, IEnumerable<int> variableValues)
+      : base(variableName) {
+      if (variableValues.Count() != variableValues.Distinct().Count()) {
+        throw new ArgumentException("variableValues have to be distinct.");
+      }
+      possibleFeatures = variableValues;
+      Wildcard = false;
+    }
+    public IntVariable(string variableName, IEnumerable<int> variableValues, int currentValue)
+      : this(variableName, variableValues) {
+      CurrentValue = currentValue;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new IntVariable(this, cloner);
+    }
+
+    public override string ToString() {
+      return currentValue.ToString();
+    }
+
+    public override bool MatchInput(string target) {
+      return Match(int.Parse(target));
+    }
+
+    public override bool Match(int target) {
+      return Wildcard || CurrentValue == target;
+    }
+
+    public override bool MatchVariable(IVariable target) {
+      var targetCast = target as IntVariable;
+      return targetCast != null && this.variableName.Equals(targetCast.VariableName) && Match(targetCast.CurrentValue);
+    }
+
+    public new IntVariable GetEmptyCopy() {
+      return new IntVariable(variableName, possibleFeatures);
+    }
+    public new IntVariable GetSetCopy() {
+      IntVariable copy = GetEmptyCopy();
+      copy.Wildcard = this.Wildcard;
+      copy.CurrentValue = this.CurrentValue;
+      return copy;
+    }
+
+    public override void Randomize(IRandom random) {
+      int index = random.Next(possibleFeatures.Count());
+      currentValue = possibleFeatures.ElementAt(index);
+    }
+
+    public override bool Identical(IVariable target) {
+      var targetCast = target as IntVariable;
+      if (targetCast == null) { return false; }
+      if (variableName != targetCast.variableName || Wildcard != targetCast.Wildcard
+        || currentValue != targetCast.currentValue) { return false; }
+
+      if (possibleFeatures.Except(targetCast.possibleFeatures).Count() != 0
+        || targetCast.possibleFeatures.Except(possibleFeatures).Count() != 0) { return false; }
+
+      return true;
+    }
+
+    public override double GetGenerality() {
+      return Wildcard ? 1 : 0;
+    }
+
+    public override bool IsGreaterThanOrEquallyGeneral(IVariable target) {
+      var targetCast = target as IntVariable;
+      if (targetCast == null) { return false; }
+      return Wildcard || currentValue == targetCast.currentValue;
+    }
+
+    public new IntVariable CrossParentsAtPosition(IVariable parent2, int pos) {
+      var parent2Cast = parent2 as IntVariable;
+      if (parent2Cast == null) { throw new ArgumentException("Argument is not of the correct type."); }
+      if (pos != 0) { throw new ArgumentOutOfRangeException(); }
+      return this.GetSetCopy();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/StringVariable.cs	(revision 9194)
@@ -0,0 +1,200 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item(Name = "StringVariable", Description = "")]
+  public class StringVariable : Variable<string>, IActionVariable {
+
+    public override int VirtualLength {
+      get { return 1; }
+    }
+
+    [Storable]
+    public bool Wildcard { get; set; }
+
+    [Storable]
+    protected IEnumerable<int> possibleFeatures;
+    public IEnumerable<int> PossibleFeatures {
+      get { return possibleFeatures; }
+    }
+
+    [Storable]
+    protected IDictionary<int, string> featureMapping;
+    public IDictionary<int, string> FeatureMapping {
+      get { return featureMapping; }
+    }
+
+    [Storable]
+    protected int currentValue;
+    public int CurrentValue {
+      get { return currentValue; }
+      set {
+        if (!possibleFeatures.Contains(value)) {
+          throw new ArgumentException("Value is not a possible feature of this variable.");
+        }
+        currentValue = value;
+      }
+    }
+
+    public string CurrentStringValue {
+      get { return featureMapping[currentValue]; }
+    }
+
+    [StorableConstructor]
+    protected StringVariable(bool deserializing) : base(deserializing) { }
+    protected StringVariable(StringVariable original, Cloner cloner)
+      : base(original, cloner) {
+      this.possibleFeatures = new List<int>(original.possibleFeatures);
+      this.featureMapping = new Dictionary<int, string>(original.featureMapping);
+      this.Wildcard = original.Wildcard;
+    }
+    public StringVariable()
+      : base() {
+      Wildcard = false;
+    }
+    public StringVariable(string variableName, IEnumerable<string> variableValues)
+      : base(variableName) {
+      if (variableValues.Count() != variableValues.Distinct().Count()) {
+        throw new ArgumentException("variableValues have to be distinct.");
+      }
+      featureMapping = new Dictionary<int, string>();
+      var distinctValuesEnumerator = variableValues.Distinct().GetEnumerator();
+      possibleFeatures = Enumerable.Range(0, featureMapping.Count());
+      var possibleFeaturesEnumerator = possibleFeatures.GetEnumerator();
+      while (possibleFeaturesEnumerator.MoveNext() && distinctValuesEnumerator.MoveNext()) {
+        featureMapping.Add(possibleFeaturesEnumerator.Current, distinctValuesEnumerator.Current);
+      }
+      Wildcard = false;
+    }
+    public StringVariable(string variableName, IEnumerable<string> variableValues, string currentValue)
+      : this(variableName, variableValues) {
+      int index = 0;
+      foreach (var feature in featureMapping) {
+        if (feature.Equals(currentValue)) {
+          break;
+        }
+        index++;
+      }
+      if (index > featureMapping.Count()) { throw new ArgumentException("variableValues do not contain currentValue."); }
+      CurrentValue = index;
+    }
+    public StringVariable(string variableName, IDictionary<int, string> featureMapping)
+      : base(variableName) {
+      if (featureMapping.Values.Count != featureMapping.Values.Distinct().Count()) {
+        throw new ArgumentException("featureMapping values have to be distinct.");
+      }
+      this.possibleFeatures = featureMapping.Keys;
+      this.featureMapping = featureMapping;
+      Wildcard = false;
+    }
+    public StringVariable(string variableName, IDictionary<int, string> featureMapping, string currentValue)
+      : this(variableName, featureMapping) {
+      bool found = false;
+      foreach (var pair in featureMapping) {
+        if (pair.Value.Equals(currentValue)) {
+          CurrentValue = pair.Key;
+          found = true;
+          break;
+        }
+      }
+      if (!found) {
+        throw new ArgumentException("variableValues do not contain currentValue.");
+      }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StringVariable(this, cloner);
+    }
+
+    public override string ToString() {
+      return CurrentStringValue;
+    }
+
+    public override bool MatchInput(string target) {
+      return Wildcard || featureMapping[CurrentValue].Equals(target);
+    }
+
+    public override bool Match(string target) {
+      return MatchInput(target);
+    }
+
+    public override bool MatchVariable(IVariable target) {
+      var targetCast = target as StringVariable;
+      return targetCast != null && this.variableName.Equals(targetCast.VariableName) && Match(targetCast.CurrentStringValue);
+    }
+
+    public new StringVariable GetEmptyCopy() {
+      return new StringVariable(variableName, featureMapping);
+    }
+    public new StringVariable GetSetCopy() {
+      StringVariable copy = GetEmptyCopy();
+      copy.Wildcard = this.Wildcard;
+      copy.CurrentValue = this.CurrentValue;
+      return copy;
+    }
+
+    public override void Randomize(IRandom random) {
+      int index = random.Next(possibleFeatures.Count());
+      currentValue = possibleFeatures.ElementAt(index);
+    }
+
+    public override bool Identical(IVariable target) {
+      var targetCast = target as StringVariable;
+      if (targetCast == null) { return false; }
+      if (variableName != targetCast.variableName || Wildcard != targetCast.Wildcard
+        || currentValue != targetCast.currentValue) { return false; }
+
+      if (featureMapping.Keys.Except(targetCast.featureMapping.Keys).Count() != 0
+        || targetCast.featureMapping.Keys.Except(featureMapping.Keys).Count() != 0) { return false; }
+
+      foreach (var keyValuePair in targetCast.featureMapping) {
+        if (!featureMapping[keyValuePair.Key].Equals(keyValuePair.Value)) { return false; }
+      }
+
+      return true;
+    }
+
+    public override double GetGenerality() {
+      return Wildcard ? 1 : 0;
+    }
+
+    public override bool IsGreaterThanOrEquallyGeneral(IVariable target) {
+      var targetCast = target as StringVariable;
+      if (targetCast == null) { return false; }
+      return Wildcard || (currentValue == targetCast.currentValue && CurrentStringValue.Equals(targetCast.CurrentStringValue));
+    }
+
+    public new StringVariable CrossParentsAtPosition(IVariable parent2, int pos) {
+      var parent2Cast = parent2 as StringVariable;
+      if (parent2Cast == null) { throw new ArgumentException("Argument is not of the correct type."); }
+      if (pos != 0) { throw new ArgumentOutOfRangeException(); }
+      return this.GetSetCopy();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/Variable.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/Variable.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/Variable/Variable.cs	(revision 9194)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [Item("Variable", "")]
+  [StorableClass]
+  public abstract class Variable<T> : Item, IVariable {
+
+    [Storable]
+    protected string variableName;
+    public string VariableName {
+      get { return variableName; }
+    }
+
+    public abstract int VirtualLength { get; }
+
+    public Type VariableType { get { return typeof(T); } }
+
+    [StorableConstructor]
+    protected Variable(bool deserializing) : base(deserializing) { }
+    protected Variable(Variable<T> original, Cloner cloner)
+      : base(original, cloner) {
+      this.variableName = (string)original.variableName.Clone();
+    }
+    public Variable() : base() { }
+    public Variable(string variableName)
+      : base() {
+      this.variableName = variableName;
+    }
+
+    public virtual IVariable GetEmptyCopy() { throw new NotSupportedException("This method is not supported. It should be implemented by every non abstract class."); }
+    public virtual IVariable GetSetCopy() { throw new NotSupportedException("This method is not supported. It should be implemented by every non abstract class."); }
+
+    public abstract void Randomize(IRandom random);
+
+    public virtual bool MatchVariable(IVariable target) { throw new NotSupportedException("This method is not supported by this kind of Variable."); }
+    public abstract bool Match(T target);
+
+    public abstract bool MatchInput(string target);
+
+    public abstract bool Identical(IVariable target);
+
+    public abstract double GetGenerality();
+
+    public abstract bool IsGreaterThanOrEquallyGeneral(IVariable target);
+
+    public virtual IVariable CrossParentsAtPosition(IVariable parent2, int pos) { throw new NotSupportedException("This method is not supported."); }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVector.cs	(revision 9194)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.VariableVector/3.3/VariableVector.cs	(revision 9194)
@@ -0,0 +1,134 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ConditionActionEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.VariableVector {
+  [StorableClass]
+  [Item("VariableVector", "")]
+  public class VariableVector : Item, IClassifier {
+    [Storable]
+    protected VariableVectorCondition condition;
+    public VariableVectorCondition Condition { get { return condition; } }
+
+    [Storable]
+    protected VariableVectorAction action;
+    public VariableVectorAction Action { get { return action; } }
+
+    public int Count {
+      get { return condition.Count + action.Count; }
+    }
+
+    public int VirtualLength {
+      get { return condition.Values.Sum(x => x.VirtualLength) + action.Values.Sum(x => x.VirtualLength); }
+    }
+
+    [StorableConstructor]
+    protected VariableVector(bool deserializing) : base(deserializing) { }
+    protected VariableVector(VariableVector original, Cloner cloner)
+      : base(original, cloner) {
+      condition = new VariableVectorCondition(original.condition);
+      action = new VariableVectorAction(original.action);
+    }
+    public VariableVector() {
+      condition = new VariableVectorCondition();
+      action = new VariableVectorAction();
+    }
+    public VariableVector(IEnumerable<IVariable> condition, IEnumerable<IVariable> action)
+      : this() {
+      if (condition == null || action == null) { throw new ArgumentNullException(); }
+      if (action.All(x => x is IActionVariable)) { throw new ArgumentException("Action can only use IActionVariable"); }
+      this.Condition.Add(condition);
+      this.Action.Add(action.Cast<IActionVariable>());
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableVector(this, cloner);
+    }
+
+    public override string ToString() {
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[");
+      sb.Append(condition.ToString());
+      sb.Append("||");
+      sb.Append(action.ToString());
+      sb.Append("]");
+      return sb.ToString();
+    }
+
+    public void Randomize(IRandom random, double spreadPercentage) {
+      condition.Randomize(random, spreadPercentage);
+      action.Randomize(random);
+    }
+
+    ICondition IClassifier.Condition {
+      get { return Condition; }
+    }
+
+    IAction IClassifier.Action {
+      get { return Action; }
+    }
+
+    public bool MatchInput(IInput target) {
+      return Condition.Match(target);
+    }
+
+    public bool MatchAction(IAction target) {
+      return Action.Match(target);
+    }
+
+    public bool IsMoreGeneral(IClassifier target) {
+      return IsMoreGeneral(target.Condition);
+    }
+
+    public bool IsMoreGeneral(ICondition target) {
+      var targetCast = target as VariableVector;
+      if (targetCast == null) { return false; }
+      if (Condition.Keys.Except(targetCast.Condition.Keys).Count() != 0
+        || targetCast.Condition.Keys.Except(Condition.Keys).Count() != 0) { return false; }
+
+      double thisGenerality = Condition.Values.Sum(x => x.GetGenerality());
+      double targetGenerality = Condition.Values.Sum(x => x.GetGenerality());
+      if (thisGenerality <= targetGenerality) { return false; }
+
+      foreach (var variables in targetCast.Condition) {
+        if (!Condition[variables.Key].IsGreaterThanOrEquallyGeneral(variables.Value)) {
+          return false;
+        }
+      }
+      return true;
+    }
+
+    public bool Identical(IClassifier target) {
+      var targetCast = target as VariableVector;
+      if (targetCast == null) { return false; }
+      if (!condition.Identical(targetCast.condition)) { return false; }
+      if (!action.Identical(targetCast.condition)) { return false; }
+      return true;
+    }
+  }
+}
